let dappaccount = {};
const dotenv = require("dotenv");
dotenv.config();
let { PrivateKey } = require("eosjs-ecc");
let helperaction = require("./common/helper");
let config = require("./common/endpoint");
const axios = require("axios").default;

dappaccount.register_both = async (email, contact, otp) => {
  try {
    let prv_key = await PrivateKey.randomKey();
    prv_key = prv_key.toWif();
    const response_reg = await helperaction.reguser(
      email,
      contact,
      otp,
      prv_key
    );
    return response_reg;
  } catch (err) {
    throw new Error(err);
  }
};

dappaccount.verifycontact = async (contact) => {
  try {
    let resp = await axios.post(config.twofactregcon, {
      contact: contact,
    });
    return resp.data;
  } catch (err) {
    throw new Error(err.response.data.message);
  }
};

dappaccount.verifyemailreg = async (email) => {
  try {
    let resp = await axios.post(config.twofactregemail, {
      email: email,
    });
    return resp.data;
  } catch (err) {
    throw new Error(err.response.data.message);
  }
};

dappaccount.verifyemailreset = async (email) => {
  try {
    let dappacc = await helperaction.converttovacc(email.toLowerCase());
    let resp = await axios.post(config.twofactlogin, {
      vaccount: dappacc,
      email: email,
    });
    return resp.data;
  } catch (err) {
    throw new Error(err.response.data.message);
  }
};

dappaccount.recover = async (email, auth_code) => {
  try {
    let prv_key = await PrivateKey.randomKey();
    prv_key = prv_key.toWif();
    const response_reg = await helperaction.recoveruser(
      email,
      auth_code,
      prv_key
    );
    return response_reg;
  } catch (err) {
    throw new Error(err);
  }
};


module.exports = dappaccount;
